<template>
  <li>
    <h1>{{ selectedWork.topic }}</h1>
    <h2>Termin: {{ showOpenDate }} - {{ showCloseDate }}</h2>
    <p>{{ selectedWork.description }}</p>
    <div v-if="!isSubmitted && !submit">
      <submit-work v-if="response" :uuid="selectedWork.uuId" @change-status="changeStatus"></submit-work>
      <base-button v-if="isStudent" @click="toggleResponse">{{
          showButtonText
        }}</base-button>
    </div>
    <div v-else>
      <h2>Praca została wysłana.</h2>
    </div>
    <base-button v-if="isLecturer" link :to="submittedLink">Zobacz odpowiedzi</base-button>
  </li>
</template>

<script setup>
import SubmitWork from "@/components/SubmitWork.vue";
import { defineProps, computed, ref } from "vue";
import { useRoute } from "vue-router";
import { useStore } from "vuex";

const route = useRoute();
const store = useStore();

const props = defineProps([
  "isStudent",
  "isLecturer",
  "id",
]);

const response = ref(false);
const selectedWork = ref(null);
const submit = ref(false);

const showOpenDate = computed(function () {
  const date = selectedWork.value.openDate;
  return (
    date.substring(8, 10) +
    "." +
    date.substring(5, 7) +
    "." +
    date.substring(0, 4)
  );
});
const showCloseDate = computed(function () {
  const date = selectedWork.value.closeDate;
  return (
    date.substring(8, 10) +
    "." +
    date.substring(5, 7) +
    "." +
    date.substring(0, 4)
  );
});
const showButtonText = computed(function () {
  return response.value ? "Nie odpowiadaj" : "Odpowiedz";
});
const submittedLink = computed(function () {
  return route.path + "/" + props.id;
});
const isSubmitted = computed(function () {
  const userId = store.getters.userId;
  return selectedWork.value["submits"].some(w => w.userId.toString() === userId.toString())
});

function toggleResponse() {
  response.value = !response.value;
}
function changeStatus() {
  submit.value = true;
}

selectedWork.value = store.getters.works.find(work => work.id === props.id);
submit.value = isSubmitted.value;
</script>

<style scoped>
li {
  margin: 1rem 0;
  border: 1px solid #424242;
  border-radius: 12px;
  padding: 1rem;
}

h1 {
  margin: 0;
}

h2 {
  margin: 0.2rem 0;
}

p {
  margin-top: 0.5rem;
  margin-bottom: 1rem;
}
</style>
